SystemOrganization addCategory: #FacebookAPI!

Object subclass: #FaceBookTestUser
	instanceVariableNames: 'accessToken email facebookID loginUrl password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FacebookAPI'!

!FaceBookTestUser methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 02:20'!
accessToken
	^ accessToken! !

!FaceBookTestUser methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 02:20'!
accessToken: anObject
	accessToken := anObject! !

!FaceBookTestUser methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 02:20'!
email
	^ email! !

!FaceBookTestUser methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 02:20'!
email: anObject
	email := anObject! !

!FaceBookTestUser methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 02:20'!
facebookID
	^ facebookID! !

!FaceBookTestUser methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 02:20'!
facebookID: anObject
	facebookID := anObject! !

!FaceBookTestUser methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 02:20'!
loginUrl
	^ loginUrl! !

!FaceBookTestUser methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 02:20'!
loginUrl: anObject
	loginUrl := anObject! !

!FaceBookTestUser methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 02:20'!
password
	^ password! !

!FaceBookTestUser methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 02:20'!
password: anObject
	password := anObject! !

Object subclass: #FaceBookUser
	instanceVariableNames: 'dateCreated dateUpdated sendCount receiveCount'
	classVariableNames: 'UsersList'
	poolDictionaries: ''
	category: 'FacebookAPI'!

!FaceBookUser class methodsFor: 'accessing' stamp: 'SergioRuiz 10/6/2012 00:22'!
users
	UsersList isNil ifTrue: [UsersList := OrderedCollection new].
	^ UsersList ! !

!FaceBookUser methodsFor: 'accessing' stamp: 'SergioRuiz 10/6/2012 00:14'!
dateCreated
	^ dateCreated! !

!FaceBookUser methodsFor: 'accessing' stamp: 'SergioRuiz 10/6/2012 00:14'!
dateCreated: anObject
	dateCreated := anObject! !

!FaceBookUser methodsFor: 'accessing' stamp: 'SergioRuiz 10/6/2012 00:14'!
dateUpdated
	^ dateUpdated! !

!FaceBookUser methodsFor: 'accessing' stamp: 'SergioRuiz 10/6/2012 00:14'!
dateUpdated: anObject
	dateUpdated := anObject! !

!FaceBookUser methodsFor: 'accessing' stamp: 'SergioRuiz 10/6/2012 00:14'!
receiveCount
	^ receiveCount! !

!FaceBookUser methodsFor: 'accessing' stamp: 'SergioRuiz 10/6/2012 00:14'!
receiveCount: anObject
	receiveCount := anObject! !

!FaceBookUser methodsFor: 'accessing' stamp: 'SergioRuiz 10/6/2012 00:14'!
sendCount
	^ sendCount! !

!FaceBookUser methodsFor: 'accessing' stamp: 'SergioRuiz 10/6/2012 00:14'!
sendCount: anObject
	sendCount := anObject! !

Object subclass: #FacebookGraph
	instanceVariableNames: 'userToken appSecret appID appToken encodedSig'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FacebookAPI'!

!FacebookGraph methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 01:06'!
appID
	^ appID! !

!FacebookGraph methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 01:06'!
appID: anObject
	appID := anObject! !

!FacebookGraph methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 01:03'!
appSecret
	^ appSecret! !

!FacebookGraph methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 01:03'!
appSecret: anObject
	appSecret := anObject! !

!FacebookGraph methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 01:50'!
appToken
	appToken ifNil: [ self setAppToken ].
	^ appToken ! !

!FacebookGraph methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 01:35'!
appToken: anObject
	appToken := anObject! !

!FacebookGraph methodsFor: 'private' stamp: 'SergioRuiz 9/29/2012 02:56'!
buildTestUser: userParams
	|facebookUser |

	facebookUser := FaceBookTestUser new.
	facebookUser accessToken: (userParams  at: 'access_token').
	facebookUser email: (userParams  at: 'email').
	facebookUser facebookID: (userParams  at: 'id').
	facebookUser loginUrl: (userParams  at: 'login_url').
	facebookUser password: (userParams  at: 'password').
	
	^ facebookUser! !

!FacebookGraph methodsFor: 'private' stamp: 'SergioRuiz 9/29/2012 02:44'!
createFullname
	| userName firstNames lastNames |
	firstNames := #(#Bill #Frank #Pedro #Jaime #WIll #WIlly #Franklin #Sue #Susan #Kathy #Cathy).
	lastNames := #(#Brown #Black #White #Green #Wilson #Franklin #Hoover #Washington).
	userName := firstNames shuffled first , ' ' , lastNames shuffled first.
	^ userName! !

!FacebookGraph methodsFor: 'public-facing' stamp: 'SergioRuiz 9/29/2012 02:58'!
createTestUser
	"creates test users for facebook"
	| userName callUrl testUser facebookUser userParams response |
	
	userName := self createFullname.
	callUrl := self urlRoot , 'installed=true&name=' , userName
		, '&local=en_US&permissions=read_stream&method=post&access_token=' , self appToken.
		
	response := callUrl asUrl retrieveContents contentStream.
	userParams := NeoJSONReader fromString: response.
	facebookUser := self buildTestUser: userParams.

	^ facebookUser! !

!FacebookGraph methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 18:14'!
encodedSig
	^ encodedSig! !

!FacebookGraph methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 18:14'!
encodedSig: anObject
	encodedSig := anObject! !

!FacebookGraph methodsFor: 'private' stamp: 'SergioRuiz 10/1/2012 00:01'!
hmacSHA256: aString key: aKey
        ^ (SHA256 new hmac)
                key: aKey asByteArray;
                digestMessage: aString asByteArray! !

!FacebookGraph methodsFor: 'as yet unclassified' stamp: 'SergioRuiz 9/29/2012 01:45'!
initialize
	super initialize .
	! !

!FacebookGraph methodsFor: 'public-facing' stamp: 'SergioRuiz 9/30/2012 11:19'!
setAppToken
	|apiUrl response|
	
	apiUrl := 'https://graph.facebook.com/oauth/access_token?client_id=', self appID, '&client_secret=', self appSecret, '&grant_type=client_credentials'.
	response := apiUrl asUrl retrieveContents contentStream.
	response inspect.
	self appToken: ((response contents subStrings: '=') at: 2).! !

!FacebookGraph methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 01:57'!
urlRoot

	^ 'https://graph.facebook.com/', self appID ,'/accounts/test-users?'.! !

!FacebookGraph methodsFor: 'accessing' stamp: 'SergioRuiz 9/28/2012 22:07'!
urlRoot: anObject
	urlRoot := anObject! !

!FacebookGraph methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 01:01'!
userToken
	^ userToken! !

!FacebookGraph methodsFor: 'accessing' stamp: 'SergioRuiz 9/29/2012 01:01'!
userToken: anObject
	userToken := anObject! !
